%error = ForceRequiredAddOn("Event_Vehicle");

if(%error == $Error::AddOn_NotFound)
{
   error("ERROR: Event_VehicleGravity - required add-on Event_Vehicle not found");
   return;
}

function Vehicle::setShiftingGravity(%this,%enabled){
	if(%enabled) {
		%this.isshiftinggravity=1;
		%this.grav="0 0 -0.5";
		shiftgravitycheck(%this);
	} else
		%this.isshiftinggravity=0;
}

registerOutputEvent(Vehicle,"setShiftingGravity","bool",0); 

function shiftgravitycheck(%obj)
{
 if(!%obj.isshiftinggravity)
  return;
 %pos=%obj.getposition();
 %typemasks = $typemasks::fxbrickobjecttype | $typemasks::interiorobjecttype | $typemasks::terrainobjecttype | $typemasks::StaticObjectType;
 %ray=containerraycast(%pos,vectoradd(%pos,vectorscale(%obj.getupvector(),"-4 -4 -4")),%typemasks,%obj);
 %normal=getwords(%ray,4,6);
 if(%normal!$="")
  %obj.grav=vectorscale(%normal,"-0.5 -0.5 -0.5");
 %obj.setvelocity(vectoradd(%obj.getvelocity(),vectoradd("0 0 0.5",%obj.grav)));
 schedule(25,0,shiftgravitycheck,%obj);
}